function area=ComputeArea(q,me)
% function area=ComputeArea(q,me)
%   Computation of areas of triangles in the mesh
%   - Basic version.
%   
% Parameters:
%  q: Array of vertices coordinates, 2-by-nq array.
%     q(il,j) is the il-th coordinate of the j-th vertex, il in {1,2}
%     and j in {1,...,nq}.
%  me: Connectivity array, 3-by-nme array.
%      me(jl,k) is the storage index of the jl-th  vertex 
%      of the k-th triangle in the array q of vertices coordinates,
%      jl in {1,2,3} and k in {1,...,nme}.
%
% Return values:
%  area: Array of areas, 1-by-nme array. area(k) is the area
%        of the k-th triangle.
%
% OptFEM2DP1 [V1.2b1] -    Copyright (C) 2013  CJS (LAGA)
%
%   This file is part of OptFEM2DP1.
%   OptFEM2DP1 is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   OptFEM2DP1 is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.
nq=size(q,2);
nme=size(me,2);
area=zeros(1,nme);
for k=1:nme
  area(k)=0.5*abs(det([ q(1,me(1,k))  q(2,me(1,k)) 1 ; ...
                        q(1,me(2,k))  q(2,me(2,k)) 1 ; ...
                        q(1,me(3,k))  q(2,me(3,k)) 1 ]));
end
